Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2232)
@@ -4399,5 +5199,12 @@
          ELSEIF ( edge == 'n' )  THEN
             DO  i = nxl, nxr + 1
-               DO  k = kb(j,i), nzt+1
+!
+!--            Determine vertical index of topography top at grid point (j,i)
+               k_wall = MAXLOC(                                                &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr2 )   &
+                          ), DIM = 1                                           &
+                              ) - 1
+               DO  k = k_wall, nzt+1
                   f(k,j,i) = tkefactor_n(k,i) * f(k,j,i)
                ENDDO
@@ -4510,5 +5317,5 @@
 
 
-    SUBROUTINE pmci_extrap_ifoutflow_lr( f, kb, edge, var )
+    SUBROUTINE pmci_extrap_ifoutflow_lr( f, edge, var )
 !
 !--    After the interpolation of ghost-node values for the child-domain
@@ -4524,12 +5331,12 @@
        CHARACTER(LEN=1), INTENT(IN) ::  var    !:
 
-       INTEGER(iwp) ::  i     !:
-       INTEGER(iwp) ::  ib    !:
-       INTEGER(iwp) ::  ibgp  !:
-       INTEGER(iwp) ::  ied   !:
-       INTEGER(iwp) ::  j     !:
-       INTEGER(iwp) ::  k     !:
-      
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb   !:
+       INTEGER(iwp) ::  flag_nr !: Number of flag array to mask topography on respective u/v/w or s grid
+       INTEGER(iwp) ::  i       !:
+       INTEGER(iwp) ::  ib      !:
+       INTEGER(iwp) ::  ibgp    !:
+       INTEGER(iwp) ::  ied     !:
+       INTEGER(iwp) ::  j       !:
+       INTEGER(iwp) ::  k       !:
+       INTEGER(iwp) ::  k_wall  !:
 
        REAL(wp) ::  outnor    !:
@@ -4557,7 +5364,25 @@
           outnor = 1.0_wp
        ENDIF
+!
+!--    Determine number of flag array to be used to mask topography
+       IF ( var == 'u' )  THEN
+          flag_nr  = 14
+       ELSEIF ( var == 'v' )  THEN
+          flag_nr  = 16
+       ELSEIF ( var == 'w' )  THEN
+          flag_nr  = 18
+       ELSE
+          flag_nr  = 12
+       ENDIF
 
        DO  j = nys, nyn+1
-          DO  k = kb(j,i), nzt+1
+!
+!--       Determine vertical index of topography top at grid point (j,i)
+          k_wall = MAXLOC(                                                     &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr )    &
+                          ), DIM = 1                                           &
+                         ) - 1
+          DO  k = k_wall, nzt+1
              vdotnor = outnor * u(k,j,ied)
 !
@@ -4568,5 +5393,5 @@
           ENDDO
           IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
-             f(kb(j,i),j,i) = 0.0_wp
+             f(k_wall,j,i) = 0.0_wp
           ENDIF
        ENDDO
@@ -4588,5 +5413,5 @@
 
 
-    SUBROUTINE pmci_extrap_ifoutflow_sn( f, kb, edge, var )
+    SUBROUTINE pmci_extrap_ifoutflow_sn( f, edge, var )
 !
 !--    After  the interpolation of ghost-node values for the child-domain
@@ -4601,4 +5426,5 @@
        CHARACTER(LEN=1), INTENT(IN) ::  var    !:
       
+       INTEGER(iwp) ::  flag_nr   !: Number of flag array to mask topography on respective u/v/w or s grid
        INTEGER(iwp) ::  i         !:
        INTEGER(iwp) ::  j         !:
@@ -4607,6 +5433,5 @@
        INTEGER(iwp) ::  jed       !:
        INTEGER(iwp) ::  k         !:
-
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb   !:
+       INTEGER(iwp) ::  k_wall    !:
 
        REAL(wp)     ::  outnor    !:
@@ -4635,6 +5460,25 @@
        ENDIF
 
+!
+!--    Determine number of flag array to be used to mask topography
+       IF ( var == 'u' )  THEN
+          flag_nr  = 14
+       ELSEIF ( var == 'v' )  THEN
+          flag_nr  = 16
+       ELSEIF ( var == 'w' )  THEN
+          flag_nr  = 18
+       ELSE
+          flag_nr  = 12
+       ENDIF
+
        DO  i = nxl, nxr+1
-          DO  k = kb(j,i), nzt+1
+!
+!--       Determine vertical index of topography top at grid point (j,i)
+          k_wall = MAXLOC(                                                     &
+                     MERGE( 1, 0,                                              &
+                            BTEST( wall_flags_0(nzb:nzb_max,j,i), flag_nr )    &
+                          ), DIM = 1                                           &
+                         ) - 1
+          DO  k = k_wall, nzt+1
              vdotnor = outnor * v(k,jed,i)
 !
@@ -4645,5 +5489,5 @@
           ENDDO
           IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
-             f(kb(j,i),j,i) = 0.0_wp
+             f(k_wall,j,i) = 0.0_wp
           ENDIF
        ENDDO
Index: /palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/poismg_mod.f90	(revision 2232)
@@ -26,7 +26,4 @@
 ! $Id$
 !
-! 2084 2016-12-09 15:59:42Z knoop
-! Bugfix: missing rho_air_mg even/odd sorting implemented
-! 
 ! 2073 2016-11-30 14:34:05Z raasch
 ! change of openmp directives in restrict
@@ -111,6 +108,4 @@
     REAL(wp), DIMENSION(:,:), SAVE, ALLOCATABLE ::  f1_mg_b, f2_mg_b, f3_mg_b  !< blocked version of f1_mg ...
 
-    REAL(wp), DIMENSION(:,:), SAVE, ALLOCATABLE ::  rho_air_mg_b               !< blocked version of rho_air_mg
-
     INTERFACE poismg
        MODULE PROCEDURE poismg
@@ -320,7 +315,7 @@
                 kp1 = k-ind_even_odd
                 r(k,j,i) = f_mg(k,j,i)                                         &
-                      - rho_air_mg_b(k,l) * ddx2_mg(l) *                         &
+                      - rho_air_mg(k,l) * ddx2_mg(l) *                         &
                       ( p_mg(k,j,i+1) +  p_mg(k,j,i-1)  )                      &
-                      - rho_air_mg_b(k,l) * ddy2_mg(l) *                         &
+                      - rho_air_mg(k,l) * ddy2_mg(l) *                         &
                       ( p_mg(k,j+1,i) + p_mg(k,j-1,i)  )                       &
                       - f2_mg_b(k,l) * p_mg(kp1,j,i)                           &
@@ -333,7 +328,7 @@
                 kp1 = k+ind_even_odd+1
                 r(k,j,i) = f_mg(k,j,i)                                         &
-                      - rho_air_mg_b(k,l) * ddx2_mg(l) *                         &
+                      - rho_air_mg(k,l) * ddx2_mg(l) *                         &
                       ( p_mg(k,j,i+1) +  p_mg(k,j,i-1)  )                      &
-                      - rho_air_mg_b(k,l) * ddy2_mg(l) *                         &
+                      - rho_air_mg(k,l) * ddy2_mg(l) *                         &
                       ( p_mg(k,j+1,i) + p_mg(k,j-1,i)  )                       &
                       - f2_mg_b(k,l) * p_mg(kp1,j,i)                           &
@@ -766,7 +761,7 @@
                          kp1 = k-ind_even_odd
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -785,7 +780,7 @@
                          kp1 = k-ind_even_odd
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -804,7 +799,7 @@
                          kp1 = k+ind_even_odd+1
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -823,7 +818,7 @@
                          kp1 = k+ind_even_odd+1
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -854,7 +849,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -863,7 +858,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -880,7 +875,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -889,7 +884,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -906,7 +901,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -915,7 +910,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -932,7 +927,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -941,7 +936,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 rho_air_mg_b(k,l) * ddx2_mg(l) *                &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + rho_air_mg_b(k,l) * ddy2_mg(l) *                &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -1758,5 +1753,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  f1_mg, f2_mg, f3_mg, rho_air_mg
+           ONLY:  f1_mg, f2_mg, f3_mg
 
        USE control_parameters,                                                 &
@@ -1784,6 +1779,5 @@
        ALLOCATE( f1_mg_b(nzb:nzt+1,maximum_grid_level),                        &
                  f2_mg_b(nzb:nzt+1,maximum_grid_level),                        &
-                 f3_mg_b(nzb:nzt+1,maximum_grid_level),                        &
-                 rho_air_mg_b(nzb:nzt+1,maximum_grid_level) )
+                 f3_mg_b(nzb:nzt+1,maximum_grid_level) )
 
 !
@@ -1806,7 +1800,4 @@
                                           f3_mg_b(nzb:nzt_mg(grid_level)+1,l), &
                                           l )
-          CALL sort_k_to_even_odd_blocks( rho_air_mg(nzb+1:nzt_mg(grid_level),l),   &
-                                          rho_air_mg_b(nzb:nzt_mg(grid_level)+1,l), &
-                                          l )
        ENDDO
 
Index: /palm/trunk/SOURCE/poismg_noopt.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_noopt.f90	(revision 2231)
+++ /palm/trunk/SOURCE/poismg_noopt.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfixes OpenMP
 ! 
 ! Former revisions:
@@ -495,5 +495,7 @@
     END SELECT
     
-!$OMP PARALLEL PRIVATE (i,j,k,ic,jc,kc)
+!$OMP PARALLEL PRIVATE (i,j,k,ic,jc,kc, rkjim,rkjip,rkjpi,rkjmi,rkjmim,rkjpim, &
+!$OMP rkjmip, rkjpip,rkmji,rkmjim,rkmjip,rkmjpi,rkmjmi,rkmjmim,rkmjpim,rkmjmip,&
+!$OMP rkmjpip          )
 !$OMP DO
     DO  ic = nxl_mg(l), nxr_mg(l)    
